/*
 * Management of Data in Wireless Sensor Networks (MaD-WiSe)
 *
 * Copyright 2004-2006 Consiglio Nazionale delle Ricerche
 * p.le Aldo Moro, 7 00185 Roma (IT)
 * Authors are listed in the file AUTHORS.TXT
 * This file is subject to the MIT license, to be found in LICENSE.TXT
 */

#include "MsgSS.h"       // contains MAX_MSGSS_PAYLOAD_SIZE declaration 
#include "TableEntry.h"  // contains stream_type declaration 


#define MAX_OPEN_REQUESTS 6      // sarebbe meglio che fosse minore od uguale 
                                 // al numero di entrate delle tabelle degli
                                 // stream remoti
#define MAX_READ_REQUESTS 6      // sarebbe meglio che fosse minore od uguale
                                 // alla somma del numero di entrate delle
                                 // quattro tabelle di stream dichiarate a
                                 // livello stream system

typedef struct app_open_request {
	uint8_t symbolic_name;        // if symbolic_name = zero, invalid entry
	uint32_t stream_rate;
	tos_time_t start_time;//unused..
	uint8_t reliability;
	uint8_t buffer_size;
	uint16_t dest;

} app_open_request;                                     

typedef struct app_read_request {
  stream_type stream_desc;
  uint8_t num_reads;

} app_read_request;                                      

typedef struct MsgUART {
  int8_t buffer[MAX_MSGSS_PAYLOAD_SIZE];  
} MsgUART;

enum {
  AM_MSGUART = 15
};
