/********** DEBUGGING ROUTINES **********/

  #define INUSE  0x1
  #define SIZE_SZ (sizeof(size_t))

	struct malloc_chunk	{
		size_t               size;      /* Size in bytes, including overhead. */
																		/* Or'ed with INUSE if in use. */
		struct malloc_chunk* fd;        /* double links -- used only if free. */
		struct malloc_chunk* bk;
	};

	typedef struct malloc_chunk* mchunkptr;

  size_t total_malloced = 0;

	size_t mymemsize(void* ptr){
		mchunkptr p = (mchunkptr)((char*)(ptr) - sizeof(SIZE_SZ));
		size_t sz = p->size & ~(INUSE);
		return sz;
	}
		
  void *mymalloc(size_t size){
    void* ptr = malloc(size);
    total_malloced+=mymemsize(ptr);
    #ifdef VDEBUG
		  dbg(DBG_USR3, "[DBG] mymalloc: using %d bytes at 0x%x, total %d (request of %d)\n", mymemsize(ptr), ptr, total_malloced, size);
		#endif
    return ptr;
  }

	void myfree(void* ptr) {
    total_malloced-=mymemsize(ptr);
    #ifdef VDEBUG
		  dbg(DBG_USR3, "[DBG] mymalloc: freed %d bytes at 0x%x, total %d\n", mymemsize(ptr), ptr, total_malloced);
		#endif
		free(ptr);
	}

/********** END OF DEBUGGING ROUTINES **********/

