/*
 * Management of Data in Wireless Sensor Networks (MaD-WiSe)
 *
 * Copyright 2004-2006 Consiglio Nazionale delle Ricerche
 * p.le Aldo Moro, 7 00185 Roma (IT)
 * Authors are listed in the file AUTHORS.TXT
 * This file is subject to the MIT license, to be found in LICENSE.TXT
 */

#ifndef NETWORK_H
#define NETWORK_H


  enum {  // network constants
    CHANNELTABLESIZE = 8,
    CHANNEL_DURATION = 1000, // in realta' dovrebbe dipendere da hop_count e lunghezza pacchetto...
    QUEUE_SIZE   = 8,
    ND_PERIOD    = 3000,     // milliseconds between two HELLO messages sent by a node in ND phase
    MAX_ND_COUNT = 3,        // number of HELLO messages sent in a ND phase (in order to have a "good" neighbor_table)
    RECEIVE_TIME = 3000,     // time needed to receive about 256 messages (to check if a message is repeated or not)
    RANDOM_1024  = 64,   // constant needed to divide a random generated number to obtain a number in range 0:1024
    RANDOM_4096  = 16    // constant needed to divide a random generated number to obtain a number in range 0:4096
  };

  enum {
    POST_OUTQUEUETASK_DELAY = 100
  };

  enum {  // state mode of the routing table
    UNDEFINED = 0, // init
    NEIGHBORS = 1, // after receiving ND_START packet
    N_REPORT  = 2, // after receiving BUILD_TREE packet
    ROUTING   = 3  // after receiving ROUTINGTABLE from server
  };

#endif
